*** ./contrib/spi/autoinc.c.orig	2010-07-31 12:06:47.000000000 +0100
--- ./contrib/spi/autoinc.c	2010-08-15 12:55:08.000000000 +0100
***************
*** 38,44 ****
  	if (TRIGGER_FIRED_FOR_STATEMENT(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "cannot process STATEMENT events");
! 	if (TRIGGER_FIRED_AFTER(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "must be fired before event");
  
--- 38,44 ----
  	if (TRIGGER_FIRED_FOR_STATEMENT(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "cannot process STATEMENT events");
! 	if (!TRIGGER_FIRED_BEFORE(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "must be fired before event");
  
*** ./contrib/spi/insert_username.c.orig	2010-07-31 12:07:44.000000000 +0100
--- ./contrib/spi/insert_username.c	2010-08-15 12:56:59.000000000 +0100
***************
*** 41,47 ****
  	if (TRIGGER_FIRED_FOR_STATEMENT(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "insert_username: cannot process STATEMENT events");
! 	if (TRIGGER_FIRED_AFTER(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "insert_username: must be fired before event");
  
--- 41,47 ----
  	if (TRIGGER_FIRED_FOR_STATEMENT(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "insert_username: cannot process STATEMENT events");
! 	if (!TRIGGER_FIRED_BEFORE(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "insert_username: must be fired before event");
  
*** ./contrib/spi/moddatetime.c.orig	2010-07-31 12:10:47.000000000 +0100
--- ./contrib/spi/moddatetime.c	2010-08-15 12:57:35.000000000 +0100
***************
*** 47,53 ****
  		/* internal error */
  		elog(ERROR, "moddatetime: cannot process STATEMENT events");
  
! 	if (TRIGGER_FIRED_AFTER(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "moddatetime: must be fired before event");
  
--- 47,53 ----
  		/* internal error */
  		elog(ERROR, "moddatetime: cannot process STATEMENT events");
  
! 	if (!TRIGGER_FIRED_BEFORE(trigdata->tg_event))
  		/* internal error */
  		elog(ERROR, "moddatetime: must be fired before event");
  
*** ./contrib/spi/timetravel.c.orig	2010-07-31 12:13:01.000000000 +0100
--- ./contrib/spi/timetravel.c	2010-08-15 16:42:48.000000000 +0100
***************
*** 122,128 ****
  		elog(ERROR, "timetravel: cannot process STATEMENT events");
  
  	/* Should be called BEFORE */
! 	if (TRIGGER_FIRED_AFTER(trigdata->tg_event))
  		elog(ERROR, "timetravel: must be fired before event");
  
  	/* INSERT ? */
--- 122,128 ----
  		elog(ERROR, "timetravel: cannot process STATEMENT events");
  
  	/* Should be called BEFORE */
! 	if (!TRIGGER_FIRED_BEFORE(trigdata->tg_event))
  		elog(ERROR, "timetravel: must be fired before event");
  
  	/* INSERT ? */
*** ./doc/src/sgml/catalogs.sgml.orig	2010-09-04 14:38:30.000000000 +0100
--- ./doc/src/sgml/catalogs.sgml	2010-09-04 15:04:08.000000000 +0100
***************
*** 4711,4717 ****
    </indexterm>
  
    <para>
!    The catalog <structname>pg_trigger</structname> stores triggers on tables.
     See <xref linkend="sql-createtrigger">
     for more information.
    </para>
--- 4711,4717 ----
    </indexterm>
  
    <para>
!    The catalog <structname>pg_trigger</structname> stores triggers on tables and views.
     See <xref linkend="sql-createtrigger">
     for more information.
    </para>
*** ./doc/src/sgml/information_schema.sgml.orig	2010-08-31 11:57:59.000000000 +0100
--- ./doc/src/sgml/information_schema.sgml	2010-08-31 12:59:42.000000000 +0100
***************
*** 4885,4892 ****
  
    <para>
     The view <literal>triggers</literal> contains all triggers defined
!    in the current database on tables that the current user owns or has
!    some non-SELECT privilege on.
    </para>
  
    <table>
--- 4885,4892 ----
  
    <para>
     The view <literal>triggers</literal> contains all triggers defined
!    in the current database on tables and views that the current user owns
!    or has some non-SELECT privilege on.
    </para>
  
    <table>
***************
*** 4990,4997 ****
        <entry><literal>condition_timing</literal></entry>
        <entry><type>character_data</type></entry>
        <entry>
!        Time at which the trigger fires (<literal>BEFORE</literal> or
!        <literal>AFTER</literal>)
        </entry>
       </row>
  
--- 4990,4997 ----
        <entry><literal>condition_timing</literal></entry>
        <entry><type>character_data</type></entry>
        <entry>
!        Time at which the trigger fires (<literal>BEFORE</literal>,
!        <literal>AFTER</literal> or <literal>INSTEAD OF</literal>)
        </entry>
       </row>
  
***************
*** 5562,5580 ****
       <row>
        <entry><literal>is_trigger_updatable</literal></entry>
        <entry><type>yes_or_no</type></entry>
!       <entry>Applies to a feature not available in <productname>PostgreSQL</></entry>
       </row>
  
       <row>
        <entry><literal>is_trigger_deletable</literal></entry>
        <entry><type>yes_or_no</type></entry>
!       <entry>Applies to a feature not available in <productname>PostgreSQL</></entry>
       </row>
  
       <row>
        <entry><literal>is_trigger_insertable_into</literal></entry>
        <entry><type>yes_or_no</type></entry>
!       <entry>Applies to a feature not available in <productname>PostgreSQL</></entry>
       </row>
      </tbody>
     </tgroup>
--- 5562,5589 ----
       <row>
        <entry><literal>is_trigger_updatable</literal></entry>
        <entry><type>yes_or_no</type></entry>
!       <entry>
!        <literal>YES</> if the view has an <literal>INSTEAD OF</>
!        <command>UPDATE</> trigger defined on it, <literal>NO</> if not
!       </entry>
       </row>
  
       <row>
        <entry><literal>is_trigger_deletable</literal></entry>
        <entry><type>yes_or_no</type></entry>
!       <entry>
!        <literal>YES</> if the view has an <literal>INSTEAD OF</>
!        <command>DELETE</> trigger defined on it, <literal>NO</> if not
!       </entry>
       </row>
  
       <row>
        <entry><literal>is_trigger_insertable_into</literal></entry>
        <entry><type>yes_or_no</type></entry>
!       <entry>
!        <literal>YES</> if the view has an <literal>INSTEAD OF</>
!        <command>INSERT</> trigger defined on it, <literal>NO</> if not
!       </entry>
       </row>
      </tbody>
     </tgroup>
*** ./doc/src/sgml/plperl.sgml.orig	2010-09-01 15:41:47.000000000 +0100
--- ./doc/src/sgml/plperl.sgml	2010-09-01 16:51:11.000000000 +0100
***************
*** 980,986 ****
       <term><literal>$_TD-&gt;{when}</literal></term>
       <listitem>
        <para>
!        When the trigger was called: <literal>BEFORE</literal>, <literal>AFTER</literal>, or <literal>UNKNOWN</literal>
        </para>
       </listitem>
      </varlistentry>
--- 980,988 ----
       <term><literal>$_TD-&gt;{when}</literal></term>
       <listitem>
        <para>
!        When the trigger was called: <literal>BEFORE</literal>,
!        <literal>AFTER</literal>, <literal>INSTEAD OF</literal> or
!        <literal>UNKNOWN</literal>
        </para>
       </listitem>
      </varlistentry>
*** ./doc/src/sgml/plpgsql.sgml.orig	2010-08-30 20:13:35.000000000 +0100
--- ./doc/src/sgml/plpgsql.sgml	2010-09-04 19:39:00.000000000 +0100
***************
*** 3112,3120 ****
       <term><varname>TG_WHEN</varname></term>
       <listitem>
        <para>
!        Data type <type>text</type>; a string of either
!        <literal>BEFORE</literal> or <literal>AFTER</literal>
!        depending on the trigger's definition.
        </para>
       </listitem>
      </varlistentry>
--- 3112,3120 ----
       <term><varname>TG_WHEN</varname></term>
       <listitem>
        <para>
!        Data type <type>text</type>; a string of
!        <literal>BEFORE</literal>, <literal>AFTER</literal> or
!        <literal>INSTEAD OF</literal> depending on the trigger's definition.
        </para>
       </listitem>
      </varlistentry>
***************
*** 3239,3244 ****
--- 3239,3259 ----
     </para>
  
     <para>
+     <literal>INSTEAD OF</> triggers (which are always row-level triggers,
+     and may only be used on views) can return null to signal that they did
+     not perform any updates, and that the rest of the operation for this
+     row should be skipped (i.e., subsequent triggers are not fired, and the
+     <command>INSERT</>/<command>UPDATE</>/<command>DELETE</> did not occur
+     for this row). Otherwise a nonnull value should be returned, to signal
+     that the trigger performed the requested operation. For
+     <command>INSERT</> and <command>UPDATE</> operations, the return value
+     should be <varname>NEW</>, which the trigger function may modify to
+     support <command>INSERT RETURNING</> and <command>UPDATE RETURNING</>.
+     For <command>DELETE</> operations, the return value should be
+     <varname>OLD</>.
+    </para>
+ 
+    <para>
      The return value of a row-level trigger
      fired <literal>AFTER</literal> or a statement-level trigger
      fired <literal>BEFORE</> or <literal>AFTER</> is
***************
*** 3354,3359 ****
--- 3369,3453 ----
  </programlisting>
     </example>
  
+    <para>
+     A variation of the previous example uses a view joining the main table
+     to the audit table, to show when each entry was last modified. This
+     approach still records the full audit trail of changes to the table,
+     but also presents a simplified view of the audit trail, showing just
+     the last modified timestamp derived from the audit trail for each entry.
+     <xref linkend="plpgsql-view-trigger-audit-example"> shows an example
+     of an audit trigger on a view in <application>PL/pgSQL</application>.
+    </para>
+ 
+    <example id="plpgsql-view-trigger-audit-example">
+     <title>A <application>PL/pgSQL</application> View Trigger Procedure For Auditing</title>
+ 
+     <para>
+      This example uses a trigger on the view to make it updatable, and
+      ensure that any insert, update or delete of a row in the view is
+      recorded (i.e., audited) in the emp_audit table. The current time
+      and user name are recorded, together with the type of operation
+      performed, and the view displays the last modified time of each row.
+     </para>
+ 
+ <programlisting>
+ CREATE TABLE emp (
+     empname           text PRIMARY KEY,
+     salary            integer
+ );
+ 
+ CREATE TABLE emp_audit(
+     operation         char(1)   NOT NULL,
+     userid            text      NOT NULL,
+     empname           text      NOT NULL,
+     salary            integer,
+     stamp             timestamp NOT NULL
+ );
+ 
+ CREATE VIEW emp_view AS
+     SELECT e.empname,
+            e.salary,
+            max(ea.stamp) AS last_updated
+       FROM emp e
+       LEFT JOIN emp_audit ea ON ea.empname = e.empname
+      GROUP BY 1, 2;
+ 
+ CREATE OR REPLACE FUNCTION update_emp_view() RETURNS TRIGGER AS $$
+     BEGIN
+         --
+         -- Perform the required operation on emp, and create a row in emp_audit
+         -- to reflect the change made to emp.
+         --
+         IF (TG_OP = 'DELETE') THEN
+             DELETE FROM emp WHERE empname = OLD.empname;
+             IF NOT FOUND THEN RETURN NULL; END IF;
+ 
+             OLD.last_updated = now();
+             INSERT INTO emp_audit VALUES('D', user, OLD.*);
+             RETURN OLD;
+         ELSIF (TG_OP = 'UPDATE') THEN
+             UPDATE emp SET salary = NEW.salary WHERE empname = OLD.empname;
+             IF NOT FOUND THEN RETURN NULL; END IF;
+ 
+             NEW.last_updated = now();
+             INSERT INTO emp_audit VALUES('U', user, NEW.*);
+             RETURN NEW;
+         ELSIF (TG_OP = 'INSERT') THEN
+             INSERT INTO emp VALUES(NEW.empname, NEW.salary);
+ 
+             NEW.last_updated = now();
+             INSERT INTO emp_audit VALUES('I', user, NEW.*);
+             RETURN NEW;
+         END IF;
+     END;
+ $$ LANGUAGE plpgsql;
+ 
+ CREATE TRIGGER emp_audit
+ INSTEAD OF INSERT OR UPDATE OR DELETE ON emp_view
+     FOR EACH ROW EXECUTE PROCEDURE update_emp_view();
+ </programlisting>
+    </example>
+ 
     <para>
      One use of triggers is to maintain a summary table
      of another table. The resulting summary can be used in place of the
*** ./doc/src/sgml/plpython.sgml.orig	2010-09-01 18:01:23.000000000 +0100
--- ./doc/src/sgml/plpython.sgml	2010-09-01 18:14:17.000000000 +0100
***************
*** 751,757 ****
       <listitem>
        <para>
         contains one of <literal>BEFORE</>, <literal>AFTER</>,
!        or <literal>UNKNOWN</>.
        </para>
       </listitem>
      </varlistentry>
--- 751,757 ----
       <listitem>
        <para>
         contains one of <literal>BEFORE</>, <literal>AFTER</>,
!        <literal>INSTEAD OF</> or <literal>UNKNOWN</>.
        </para>
       </listitem>
      </varlistentry>
***************
*** 827,838 ****
    </para>
  
    <para>
!    If <literal>TD["when"]</literal> is <literal>BEFORE</> and
     <literal>TD["level"]</literal> is <literal>ROW</>, you can
     return <literal>None</literal> or <literal>"OK"</literal> from the
     Python function to indicate the row is unmodified,
!    <literal>"SKIP"</> to abort the event, or <literal>"MODIFY"</> to
!    indicate you've modified the row.
     Otherwise the return value is ignored.
    </para>
   </sect1>
--- 827,840 ----
    </para>
  
    <para>
!    If <literal>TD["when"]</literal> is <literal>BEFORE</> or
!    <literal>INSTEAD OF</> and
     <literal>TD["level"]</literal> is <literal>ROW</>, you can
     return <literal>None</literal> or <literal>"OK"</literal> from the
     Python function to indicate the row is unmodified,
!    <literal>"SKIP"</> to abort the event, or if <literal>TD["event"]</>
!    is <command>INSERT</> or <command>UPDATE</> you can return
!    <literal>"MODIFY"</> to indicate you've modified the new row.
     Otherwise the return value is ignored.
    </para>
   </sect1>
*** ./doc/src/sgml/pltcl.sgml.orig	2010-09-01 15:07:44.000000000 +0100
--- ./doc/src/sgml/pltcl.sgml	2010-09-01 17:48:37.000000000 +0100
***************
*** 567,574 ****
         <term><varname>$TG_when</varname></term>
         <listitem>
          <para>
!          The string <literal>BEFORE</> or <literal>AFTER</> depending on the
!          type of trigger event.
          </para>
         </listitem>
        </varlistentry>
--- 567,574 ----
         <term><varname>$TG_when</varname></term>
         <listitem>
          <para>
!          The string <literal>BEFORE</>, <literal>AFTER</> or
!          <literal>INSTEAD OF</> depending on the type of trigger event.
          </para>
         </listitem>
        </varlistentry>
***************
*** 641,650 ****
       the operation (<command>INSERT</>/<command>UPDATE</>/<command>DELETE</>) that fired the trigger will proceed
       normally. <literal>SKIP</> tells the trigger manager to silently suppress
       the operation for this row. If a list is returned, it tells PL/Tcl to
!      return a modified row to the trigger manager that will be inserted
!      instead of the one given in <varname>$NEW</>.  (This works for <command>INSERT</> and <command>UPDATE</>
!      only.) Needless to say that all this is only meaningful when the trigger
!      is <literal>BEFORE</> and <command>FOR EACH ROW</>; otherwise the return value is ignored.
      </para>
  
      <para>
--- 641,654 ----
       the operation (<command>INSERT</>/<command>UPDATE</>/<command>DELETE</>) that fired the trigger will proceed
       normally. <literal>SKIP</> tells the trigger manager to silently suppress
       the operation for this row. If a list is returned, it tells PL/Tcl to
!      return a modified row to the trigger manager. This is only meaningful
!      for row-level <literal>BEFORE</> <command>INSERT</> or <command>UPDATE</>
!      triggers for which the modified row will be inserted instead of the one
!      given in <varname>$NEW</>; or for row-level <literal>INSTEAD OF</>
!      <command>INSERT</> or <command>UPDATE</> triggers where the returned row
!      is used to support <command>INSERT RETURNING</> and
!      <command>UPDATE RETURNING</> commands. The return value is ignored for
!      other types of triggers.
      </para>
  
      <para>
*** ./doc/src/sgml/ref/create_rule.sgml.orig	2010-09-01 18:44:58.000000000 +0100
--- ./doc/src/sgml/ref/create_rule.sgml	2010-09-01 18:55:21.000000000 +0100
***************
*** 73,79 ****
     sufficient for your purposes) to replace update actions on the view
     with appropriate updates on other tables.  If you want to support
     <command>INSERT RETURNING</> and so on, then be sure to put a suitable
!    <literal>RETURNING</> clause into each of these rules.
    </para>
  
    <para>
--- 73,81 ----
     sufficient for your purposes) to replace update actions on the view
     with appropriate updates on other tables.  If you want to support
     <command>INSERT RETURNING</> and so on, then be sure to put a suitable
!    <literal>RETURNING</> clause into each of these rules.  Alternatively,
!    an updatable view may be implemented using <literal>INSTEAD OF</>
!    triggers (see <xref linkend="sql-createtrigger">).
    </para>
  
    <para>
*** ./doc/src/sgml/ref/create_trigger.sgml.orig	2010-09-01 19:04:12.000000000 +0100
--- ./doc/src/sgml/ref/create_trigger.sgml	2010-09-04 18:14:52.000000000 +0100
***************
*** 21,27 ****
  
   <refsynopsisdiv>
  <synopsis>
! CREATE TRIGGER <replaceable class="PARAMETER">name</replaceable> { BEFORE | AFTER } { <replaceable class="PARAMETER">event</replaceable> [ OR ... ] }
      ON <replaceable class="PARAMETER">table</replaceable> [ FOR [ EACH ] { ROW | STATEMENT } ]
      [ WHEN ( <replaceable class="parameter">condition</replaceable> ) ]
      EXECUTE PROCEDURE <replaceable class="PARAMETER">function_name</replaceable> ( <replaceable class="PARAMETER">arguments</replaceable> )
--- 21,27 ----
  
   <refsynopsisdiv>
  <synopsis>
! CREATE TRIGGER <replaceable class="PARAMETER">name</replaceable> { BEFORE | AFTER | INSTEAD OF } { <replaceable class="PARAMETER">event</replaceable> [ OR ... ] }
      ON <replaceable class="PARAMETER">table</replaceable> [ FOR [ EACH ] { ROW | STATEMENT } ]
      [ WHEN ( <replaceable class="parameter">condition</replaceable> ) ]
      EXECUTE PROCEDURE <replaceable class="PARAMETER">function_name</replaceable> ( <replaceable class="PARAMETER">arguments</replaceable> )
***************
*** 33,53 ****
  
    <para>
     <command>CREATE TRIGGER</command> creates a new trigger.  The
!    trigger will be associated with the specified table and will
     execute the specified function <replaceable
     class="parameter">function_name</replaceable> when certain events occur.
    </para>
  
    <para>
!    The trigger can be specified to fire either before the
     operation is attempted on a row (before constraints are checked and
     the <command>INSERT</command>, <command>UPDATE</command>, or
!    <command>DELETE</command> is attempted) or after the operation has
     completed (after constraints are checked and the
     <command>INSERT</command>, <command>UPDATE</command>, or
!    <command>DELETE</command> has completed). If the trigger fires
!    before the event, the trigger can skip the operation for the
!    current row, or change the row being inserted (for
     <command>INSERT</command> and <command>UPDATE</command> operations
     only). If the trigger fires after the event, all changes, including
     the effects of other triggers, are <quote>visible</quote>
--- 33,54 ----
  
    <para>
     <command>CREATE TRIGGER</command> creates a new trigger.  The
!    trigger will be associated with the specified table or view and will
     execute the specified function <replaceable
     class="parameter">function_name</replaceable> when certain events occur.
    </para>
  
    <para>
!    The trigger can be specified to fire before the
     operation is attempted on a row (before constraints are checked and
     the <command>INSERT</command>, <command>UPDATE</command>, or
!    <command>DELETE</command> is attempted); after the operation has
     completed (after constraints are checked and the
     <command>INSERT</command>, <command>UPDATE</command>, or
!    <command>DELETE</command> has completed); or instead of the operation
!    (in the case of inserts, updates or deletes on a view).
!    If the trigger fires before or instead of the event, the trigger can skip
!    the operation for the current row, or change the row being inserted (for
     <command>INSERT</command> and <command>UPDATE</command> operations
     only). If the trigger fires after the event, all changes, including
     the effects of other triggers, are <quote>visible</quote>
***************
*** 68,86 ****
    </para>
  
    <para>
!    In addition, triggers may be defined to fire for a
!    <command>TRUNCATE</command>, though only
!    <literal>FOR EACH STATEMENT</literal>.
    </para>
  
    <para>
!    Also, a trigger definition can specify a Boolean <literal>WHEN</>
     condition, which will be tested to see whether the trigger should
     be fired.  In row-level triggers the <literal>WHEN</> condition can
     examine the old and/or new values of columns of the row.  Statement-level
     triggers can also have <literal>WHEN</> conditions, although the feature
     is not so useful for them since the condition cannot refer to any values
!    in the table.
    </para>
  
    <para>
--- 69,144 ----
    </para>
  
    <para>
!    Triggers that are specified to fire <literal>INSTEAD OF</> the trigger
!    event must be marked <literal>FOR EACH ROW</>, and can only be defined
!    on views. <literal>BEFORE</> and <literal>AFTER</> triggers on a view
!    must be marked as <literal>FOR EACH STATEMENT</>.
    </para>
  
    <para>
!    In addition, triggers may be defined to fire for a
!    <command>TRUNCATE</command> (tables only), though only
!    <literal>FOR EACH STATEMENT</literal>. The following table
!    summarises which types of triggers may be used on tables and views:
!   </para>
! 
!   <informaltable id="supported-trigger-types">
!    <tgroup cols="4">
!     <thead>
!      <row>
!       <entry>When</entry>
!       <entry>Event</entry>
!       <entry>Row-level</entry>
!       <entry>Statement-level</entry>
!      </row>
!     </thead>
!     <tbody>
!      <row>
!       <entry align="center" morerows="1"><literal>BEFORE</></entry>
!       <entry align="center"><command>INSERT</>/<command>UPDATE</>/<command>DELETE</></entry>
!       <entry align="center">Tables</entry>
!       <entry align="center">Tables and views</entry>
!      </row>
!      <row>
!       <entry align="center"><command>TRUNCATE</></entry>
!       <entry align="center">X</entry>
!       <entry align="center">Tables</entry>
!      </row>
!      <row>
!       <entry align="center" morerows="1"><literal>AFTER</></entry>
!       <entry align="center"><command>INSERT</>/<command>UPDATE</>/<command>DELETE</></entry>
!       <entry align="center">Tables</entry>
!       <entry align="center">Tables and views</entry>
!      </row>
!      <row>
!       <entry align="center"><command>TRUNCATE</></entry>
!       <entry align="center">X</entry>
!       <entry align="center">Tables</entry>
!      </row>
!      <row>
!       <entry align="center" morerows="1"><literal>INSTEAD OF</></entry>
!       <entry align="center"><command>INSERT</>/<command>UPDATE</>/<command>DELETE</></entry>
!       <entry align="center">Views</entry>
!       <entry align="center">X</entry>
!      </row>
!      <row>
!       <entry align="center"><command>TRUNCATE</></entry>
!       <entry align="center">X</entry>
!       <entry align="center">X</entry>
!      </row>
!     </tbody>
!    </tgroup>
!   </informaltable>
! 
!   <para>
!    Also, most trigger definitions can specify a Boolean <literal>WHEN</>
     condition, which will be tested to see whether the trigger should
     be fired.  In row-level triggers the <literal>WHEN</> condition can
     examine the old and/or new values of columns of the row.  Statement-level
     triggers can also have <literal>WHEN</> conditions, although the feature
     is not so useful for them since the condition cannot refer to any values
!    in the table. <literal>INSTEAD OF</> triggers cannot be used with
!    <literal>WHEN</> conditions.
    </para>
  
    <para>
***************
*** 116,125 ****
     <varlistentry>
      <term><literal>BEFORE</literal></term>
      <term><literal>AFTER</literal></term>
      <listitem>
       <para>
!       Determines whether the function is called before or after the
!       event.
       </para>
      </listitem>
     </varlistentry>
--- 174,184 ----
     <varlistentry>
      <term><literal>BEFORE</literal></term>
      <term><literal>AFTER</literal></term>
+     <term><literal>INSTEAD OF</literal></term>
      <listitem>
       <para>
!       Determines whether the function is called before, after or instead of
!       the event.
       </para>
      </listitem>
     </varlistentry>
***************
*** 143,148 ****
--- 202,213 ----
        The trigger will only fire if at least one of the listed columns
        is mentioned as a target of the update.
       </para>
+ 
+      <para>
+       <literal>INSTEAD OF</> triggers do not support lists of columns. An
+       <literal>INSTEAD OF</> trigger must be unconditional, and is fired
+       for each affected row in the view.
+      </para>
      </listitem>
     </varlistentry>
  
***************
*** 150,156 ****
      <term><replaceable class="parameter">table</replaceable></term>
      <listitem>
       <para>
!       The name (optionally schema-qualified) of the table the trigger
        is for.
       </para>
      </listitem>
--- 215,221 ----
      <term><replaceable class="parameter">table</replaceable></term>
      <listitem>
       <para>
!       The name (optionally schema-qualified) of the table or view the trigger
        is for.
       </para>
      </listitem>
***************
*** 189,194 ****
--- 254,264 ----
       </para>
  
       <para>
+       <literal>INSTEAD OF</> triggers do not support <literal>WHEN</>
+       conditions.
+      </para>
+ 
+      <para>
        Currently, <literal>WHEN</literal> expressions cannot contain
        subqueries.
       </para>
***************
*** 326,331 ****
--- 396,411 ----
      WHEN (OLD.* IS DISTINCT FROM NEW.*)
      EXECUTE PROCEDURE log_account_update();
  </programlisting>
+ 
+    Execute the function <function>view_insert_row</> for each row to insert
+    rows into a view:
+ 
+ <programlisting>
+ CREATE TRIGGER view_insert
+     INSTEAD OF INSERT ON my_view
+     FOR EACH ROW
+     EXECUTE PROCEDURE view_insert_row();
+ </programlisting>
    </para>
  
    <para>
***************
*** 396,402 ****
  
    <para>
     The ability to fire triggers for <command>TRUNCATE</command> is a
!    <productname>PostgreSQL</> extension of the SQL standard.
    </para>
  
   </refsect1>
--- 476,485 ----
  
    <para>
     The ability to fire triggers for <command>TRUNCATE</command> is a
!    <productname>PostgreSQL</> extension of the SQL standard, as is the
!    ability to define statement-level triggers on views that fire
!    <literal>BEFORE</> or <literal>AFTER</> <command>INSERT</>,
!    <command>UPDATE</> and <command>DELETE</> commands.
    </para>
  
   </refsect1>
